<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../../common/content-types';
import {
  SupportCopyMarkdown,
  SupportHero,
} from '~/components/support/index.vue';
import { SolutionsHero } from '~/components/solutions/index.vue';
import { getPageMetadata } from '~/common/meta';
import { NextStepAlt } from '~/components/common/index.vue';
import { getClient } from '~/plugins/contentful.js';

import { supportChildDataHelper } from '~/services/support/support-child-pages-update.service';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { LivePreviewMixin } from '~/mixins';
import { StickyNav } from '~/components/solutions/ai/index.vue';
export default Vue.extend({
  components: {
    SupportHero,
    SupportCopyMarkdown,
    SolutionsHero,
    StickyNav,
    NextStepAlt,
  },
  nuxtI18n: false,
  mixins: [LivePreviewMixin],
  async asyncData() {
    try {
      const entries = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'solutions/public-sector/us-govt-support',
        include: 10,
      });

      const { pageContent } = entries.items[0].fields;
      const seoMetadata = entries.items[0].fields.seoMetadata[0].fields;

      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };

      const support = supportChildDataHelper(pageContent);
      return { support, metadata, items: entries.items };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.support = supportChildDataHelper(
            updatedData[0].fields.pageContent,
          )),
      });

      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div class="us-govt-support">
    <SlpContainer class="slp-mb-96">
      <SolutionsHero :data="support.supportHero" />
      <div
        v-for="(section, index) in support.components"
        :key="index"
        :data="section"
        :index="index"
      >
        <SlpRow>
          <SlpColumn :cols="8">
            <div class="slp-mb-24">
              <SlpTypography
                v-if="section.header"
                tag="span"
                variant="heading2-bold"
                class="support-gradient-header"
              >
                {{ section.header }}
              </SlpTypography>
              <SlpTypography
                v-if="section.subheader"
                tag="span"
                variant="heading2-bold"
              >
                {{ section.subheader }}
              </SlpTypography>
            </div>
            <SlpTypography
              v-if="section.text"
              class=""
              tag="div"
              variant="heading5"
              ><div v-html="$md.render(section.text)"></div
            ></SlpTypography> </SlpColumn
        ></SlpRow>
      </div>
    </SlpContainer>
    <StickyNav
      v-if="support.side_menu.anchors.data"
      :links="support.side_menu.anchors.data"
      class="support-nav"
    ></StickyNav>
    <div class="support-main-sections">
      <div
        v-for="(section, index) in support.cards"
        :id="section.headerAnchorId"
        :key="index"
        :index="index"
      >
        <SlpContainer>
          <div class="support-section-icon slp-mb-16">
            <SlpIcon size="xl" :icon="section.iconName" />
          </div>
          <SlpRow>
            <SlpColumn :cols="6">
              <SlpTypography
                v-if="section.title"
                tag="h2"
                variant="heading2-bold"
                class="slp-mb-16"
              >
                {{ section.title }}
              </SlpTypography>
              <SlpTypography v-if="section.title" tag="div" variant="heading5">
                <div
                  v-if="section?.description"
                  class="support-section-content"
                  v-html="$md.render(section.description)"
                ></div
              ></SlpTypography>
            </SlpColumn>
            <SlpColumn :cols="6">
              <div
                v-if="section?.column2Description"
                class="support-section-content"
                v-html="$md.render(section.column2Description)"
              ></div>
            </SlpColumn>
          </SlpRow>
        </SlpContainer>
      </div>
    </div>

    <div>
      <component
        :is="component.componentName"
        v-for="component in support.cardGroups"
        :id="component.headerAnchorId"
        :key="component.componentName"
        class="support-section"
        :data="component"
      />
    </div>
    <NextStepAlt />
  </div>
</template>

<style scoped lang="scss">
.us-govt-support {
  overflow-x: clip;
}
* {
  font-display: swap;
}
.support-gradient-header {
  background: linear-gradient(
    94deg,
    #e3995d 25.53%,
    #cb9296 64.71%,
    #7f48d6 110.72%
  );
  background-clip: text;
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
}
.support-main-sections {
  & > :nth-child(even) {
    padding: 48px 0px;
    @media (min-width: $breakpoint-md) {
      padding: 96px 0px;
    }
  }
  & > :nth-child(odd) {
    background-color: $color-surface-800;
    padding: 32px 0px 48px 0px;
    @media (min-width: $breakpoint-md) {
      padding: 64px 0px 96px 0px;
    }
  }
  &:deep {
    h3 {
      font-size: 24px;
      font-style: normal;
      font-weight: 400;
      line-height: 32px;
      letter-spacing: -0.72px;
      margin-bottom: 16px;
    }
    .slp-row {
      margin-left: -24px;
      .slp-col-md-6 {
        padding-left: 24px;
      }
    }
  }
}
.support-section-icon {
  background: linear-gradient(89deg, #eee7fd 3.12%, #ffe6e9 111.93%);
  border-radius: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  height: 96px;
  width: 96px;
  padding: 16px;
  &:deep {
    .slp-icon {
      width: 100%;
      height: 100%;
    }
  }
}
.support-section-content {
  &:deep(strong) {
    font-weight: 600;
  }
  &:deep(ul) {
    // padding-left: 32px;
    margin: 16px 0;

    li {
      // margin: 8px 0 0 24px;
      padding: 24px 0 24px 56px;
      position: relative;
      border-top: 1px solid $color-surface-200;

      &:before {
        content: '';
        position: absolute;
        top: 24px;
        left: 0;
        border: 1px solid $color-accent-400;
        border-radius: 100%;
        display: block;
        width: 30px;
        height: 30px;
      }
      &:after {
        content: url('/nuxt-images/icons/list-check-dark.svg');
        position: absolute;
        top: 24px;
        left: 0;
        width: 30px;
        height: 30px;
        text-align: center;
        justify-content: center;
        display: flex;
        align-items: center;
        line-height: 0;
      }
    }
  }
}
.support-section {
  padding: 48px 0px;
  @media (min-width: $breakpoint-md) {
    padding: 96px 0px;
  }
}
.support-nav {
  :deep {
    nav {
      background-color: $color-surface-800;
      box-shadow: 0px 2px 6px 0px rgba(0, 0, 0, 0.05);
      border-bottom: 1px solid var(--slp-color-surface-900, #eee7fd);
      a {
        color: $color-text-300;
      }
    }
  }
}
</style>
